module Hermes
  module Api
    module Dmo
      class RequiredDocumentsController < Hermes::Api::Dmo::ApplicationController
     
        before_action :set_required_document, only: [:send_file]
        MUTATE_PARAMS = %i[
  status
  ]
        
        mutate_params_only(*MUTATE_PARAMS)
        
        def set_required_document
          @required_document = Hermes::RequiredDocument.find_by(id: params[:required_document_id])
        end
        
        def send_files
          return render_json_error(:unprocessable_entity, :not_writers) unless @instance && @instance.reload && @instance.writable_by?(@user)
          file_array = params[:files]
          if file_array && file_array.length>0
            array_of_blobs = []
            file_array.each do |f|
              array_of_blobs.push({filename: f.original_filename, blob: f.read})
            end
            @instance.set_blobs(array_of_blobs)
            
          else
            return render_json_error :unprocessable_entity, :no_file_in_the_request
          end
          return respond_with_errors(@instance) unless  @instance.save
          render(jsonapi: @instance, serializer: Hermes::RequiredDocumentSerializer, base_url: request.host)
        end
    
        def update
          ap params
          #return render_json_error(:unprocessable_entity, :not_allowed) if @user.groups ... todo
          super
        end
        def create
          return render_json_error(:unprocessable_entity, :not_allowed)
        end
        def destroy
          return render_json_error(:unprocessable_entity, :not_allowed)
        end
    end
  end
end
end